#  CMake configure file for alps-alea. Defines:
#  alps-alea_FOUND        - System has alps-alea
#  alps-alea_LIBRARIES    - The alps-alea libraries (external targets)
#  alps-alea_HAS_MPI      - The alps-alea is compiled with MPI enabled

# FIXME: is not affected by alps-alea_LIBRARY

foreach(dep_ alps-utilities;alps-hdf5)
  find_package(${dep_} PATHS ${CMAKE_CURRENT_LIST_DIR}/../${dep_} NO_DEFAULT_PATH)
endforeach()
unset(dep_)

include(${CMAKE_CURRENT_LIST_DIR}/alps-alea.cmake)

set(alps-alea_HAS_MPI false)
set(alps-alea_LIBRARIES alps::alps-alea)

if (NOT ALPSCore_HAS_EIGEN_VERSION)
  set(ALPSCore_HAS_EIGEN_VERSION "3.4.0")
endif()

include(FindPackageHandleStandardArgs)
find_package_handle_standard_args(alps-alea DEFAULT_MSG alps-alea_LIBRARIES)
