#  CMake configure file for alps-params. Defines:
#  alps-params_FOUND        - System has alps-params
#  alps-params_LIBRARIES    - The alps-params libraries (external targets)
#  alps-params_HAS_MPI      - The alps-params is compiled with MPI enabled

# FIXME: is not affected by alps-params_LIBRARY

foreach(dep_ alps-utilities;alps-hdf5)
  find_package(${dep_} PATHS ${CMAKE_CURRENT_LIST_DIR}/../${dep_} NO_DEFAULT_PATH)
endforeach()
unset(dep_)

include(${CMAKE_CURRENT_LIST_DIR}/alps-params.cmake)

set(alps-params_HAS_MPI false)
set(alps-params_LIBRARIES alps::alps-params)

if (NOT ALPSCore_HAS_EIGEN_VERSION)
  set(ALPSCore_HAS_EIGEN_VERSION "")
endif()

include(FindPackageHandleStandardArgs)
find_package_handle_standard_args(alps-params DEFAULT_MSG alps-params_LIBRARIES)
