#  CMake configure file for alps-utilities. Defines:
#  alps-utilities_FOUND        - System has alps-utilities
#  alps-utilities_LIBRARIES    - The alps-utilities libraries (external targets)
#  alps-utilities_HAS_MPI      - The alps-utilities is compiled with MPI enabled

# FIXME: is not affected by alps-utilities_LIBRARY

foreach(dep_ )
  find_package(${dep_} PATHS ${CMAKE_CURRENT_LIST_DIR}/../${dep_} NO_DEFAULT_PATH)
endforeach()
unset(dep_)

include(${CMAKE_CURRENT_LIST_DIR}/alps-utilities.cmake)

set(alps-utilities_HAS_MPI false)
set(alps-utilities_LIBRARIES alps::alps-utilities)

if (NOT ALPSCore_HAS_EIGEN_VERSION)
  set(ALPSCore_HAS_EIGEN_VERSION "3.4.0")
endif()

include(FindPackageHandleStandardArgs)
find_package_handle_standard_args(alps-utilities DEFAULT_MSG alps-utilities_LIBRARIES)
